<%@ LANGUAGE="JSCRIPT" %> <%

// Contemplate Flattener (flattener.asp) version 1.0b
// Copyright 1999-2003 Type A Multimedia Network (http://www.typea.net)
// This file may be used, modified, or redistributed under the terms
// of the open-source agreement contained in docs/license.txt


	Server.ScriptTimeout = 300; // this is important for the flattener, since flattening a site can take several minutes

// this is a special JScript workaround for testing if an argument is set or not

	$undefined = Request.QueryString("alkdjfalkdjajdslkfjdalsjfdajljf");


// initialize variables that we might use before setting

	$flatten = 0;
	$unflatten = 0;
	$input_file = "";
	$output_file = "";
	$stop = 0;
	$failures = 0;
	$result = "";
	$output = "";
	$page_name = "";
	$pre_render_files = 1;
	$this_failure = 0;
	$changed = 0;
	$field_marker = "";
	$read_page_definitions_from = "";
	$unconvert_error = "";
	$changed_files = "";
	$check_URL = "";
	$settings_used = "";
	$template = "";
	$latest_mod_date = 0;


// define some useful functions
	
	function convert_URLs($text, $name) {
		// convert URLs like ../assembled/page.html
		$text = $text.replace(/assembled\//ig, "flattened/");
		
		// convert URLs like ../contemplate/assembler.asp?page=page
		$re = new RegExp("contemplate\/assembler\.asp\\?page\=([^<>\\s\'\"]+)([<>\\s\'\"])", "ig");
		$text = $text.replace($re, "flattened/" + "$1" + ".html" + "$2");
				
		// convert URLs like ../contemplate/assembler.asp?template=default&main=field,main,home
		$re = new RegExp("contemplate\/assembler\.asp\\?(template\=[^<>\\s\'\"]+)([<>\\s\'\"])", "ig");
		if ($re.test($text)) {
			$dynamic_page = RegExp.$1;
			$page_name = get_page_name($dynamic_page);
			if ($page_name != "") {
				$text = $text.replace($re, "flattened\/" + $page_name + "\.html" + "$2");
			} else {
				$result += "<font color=red>Error: Can't find a page name for " + $dynamic_page + " in " + $name + ".</font><br>";
			}
		}
		return $text;
	}

	function unconvert_URLs($text, $format_sample) {
		$flat_path = "../flattened/";
		$dynamic_path_short = "../assembled/";
		$dynamic_path_medium = "../contemplate/assembler.asp?page=";
		if (($format_sample.indexOf($dynamic_path_short) != -1)&&($format_sample.indexOf($dynamic_path_medium) != -1)) {
			$unconvert_error = "Error: Assembled page may only contain short or medium format dynamic URLs, not both<br>";
		} else {
			if ($format_sample.indexOf($dynamic_path_short) != -1) {
				// convert flattened URLs to ../assembled/page.html
				$re = new RegExp($flat_path, "ig");
				$text = $text.replace($re, $dynamic_path_short);
			} else if ($format_sample.indexOf($dynamic_path_medium) != -1) {
				// convert flattened URLs to ../contemplate/assembler.asp?page=page
				$re = new RegExp($flat_path + "([^<>\\s\'\"]+)\.html", "ig");
				$text = $text.replace($re, $dynamic_path_medium + "$1");
			}
		}
		return $text;
	}
	
	function get_file($file, $method) { // method can be "http", "filesystem", or "auto" (auto looks at $pre_render_files list)
		$text = "";
		//$output += "test3: " + $file;
		$re = new RegExp("\/(\.\w.*)", "");
		if ($re.test($file)) { // don't read files whose names start with "."
			$text = show_error("Not authorized to read hidden file named \"" + RegExp.$1 + "\"");
		} else {
			
			// first, figure out if we're going to read over HTTP or through the filesystem...
			if (($method == "")||($method == "auto")) {
				if ($pre_render_files) {
					for ($n=0; $n < $pre_render_files.length; $n++) {
						if ($file.indexOf($pre_render_files[$n]) != -1) { $method = "http"; }
					}
				}
			}

			// ...then get the file
			if ($method == "http") {

				// 1) prepare the URL for this type of connection
				$file_URL = absolute_path($file, "http");

				// 2) open a connection to the file
				XHO = Server.CreateObject("Microsoft.XMLHTTP");
				XHO.Open("GET", $file_URL, 0);
				$file_exists = 1; // to do: how can we test for this?
				if (! $file_exists) {
					$text = show_error("Can't open the file named \"" + $file + "\"" + $check_URL);
					$file_missing = 1;
				} else {
					XHO.Send();
					
					// 3) read the file
					$text = XHO.responseText;
	
					// 4) close the file connection
					XHO = "";
				}

				//$output .= "<p>reading " + $file_URL + " over http<p>";  // debug

			} else {

				// 1) prepare the URL for this type of connection
				$file_URL = absolute_path($file, "filesystem");

				// 2) open a connection to the file
				FSO = Server.CreateObject("Scripting.FileSystemObject");
				$file_exists = FSO.FileExists($file_URL);
				if (! $file_exists) {
					$text = show_error("Can't open the file named \"" + $file + "\"" + $check_URL);
					$file_missing = 1;
				} else {
				
					// 3) read the file
					$myfile = FSO.OpenTextFile($file_URL, 1);
					$text = $myfile.ReadAll();
					$file_missing = 0;
	
					// 4) for local files, catch the file's modification date (for $read_page_definitions_from and $template, plus content files when the template contains a env_last_modified tag)
					if ((($file.toLowerCase().indexOf($read_page_definitions_from) != -1)||($file.toLowerCase().indexOf($template) != -1)||($embeds_string.toLowerCase().indexOf("env_last_modified") != -1))&&($file != "preferences.ini")) {
						$myfile2 = FSO.getFile($file_URL);
						$ASP_date = $myfile2.dateLastModified;
						$JScript_date = new Date($ASP_date);
						$mtime = $JScript_date.getTime();
						if ($mtime > $latest_mod_date) {
							$latest_mod_date = $mtime;
							$year = $JScript_date.getFullYear();
							$month = $JScript_date.getMonth() + 1; if ($month < 10) { $month = "0" + String($month); }
							$day = $JScript_date.getDate(); if ($day < 10) { $day = "0" + String($day); }
							$hour = $JScript_date.getHours(); if ($hour < 10) { $hour = "0" + String($hour); }
 							if ($hour > 12) {
 								$hour = $hour - 12;
 								$ampm = "pm";
 							} else {
 								$ampm = "am";
 							}
							$minute = $JScript_date.getMinutes(); if ($minute < 10) { $minute = "0" + String($minute); }
							$latest_mod_date_formatted = $year + "-" + $month + "-" + $day + " - " + $hour + ":" + $minute + " " + $ampm;
						}
					}
			
					// 5a) close the file connection
					$myfile.Close();
					
				}

				// 5b) close the file connection
				FSO = "";

				//$output += "<p>reading " + $file_URL + " through filesystem<p>"; // debug
				
			}
							
			// finally, conform all line breaks to avoid cross-platform issues
			// we'd rather conform to Unix line breaks (\n), but that doesn't work in ASP, which doesn't support the s flag in regular expressions
			$text = $text.replace(/\r\n/g, "\r"); // change DOS to Mac
			$text = $text.replace(/\n/g, "\r"); // change Unix to Mac
			
		}
		return $text;
	}
	
	function get_setting($source_text, $setting, $allow_override, $allow_partial) {
		// allow most preferences to be overridden through the argument string
		$value = "";
		$setting_no_spaces = $setting;
		$setting_no_spaces = String($setting_no_spaces).replace(/[ -]/g, "_");
		$settings_used += $setting_no_spaces + ",";

		$override = (Request.QueryString($setting_no_spaces) != $undefined) ? Request.QueryString($setting_no_spaces) : "" ;
		if (($allow_override)&&($override != "")) {
			$value = $override;
		} else {
			$source_text = "\r" + $source_text; // this makes it easy to make sure settings start on a new line
			if ($allow_partial) {  // this lets us use more verbose labels in the ini file
				$re = new RegExp('[^\\w]' + $setting + '[^:\r]*: ([^\r]*)\r*', 'i');
				if ($re.test($source_text)) {
					$value = RegExp.$1;
				}
			} else {  // this ensures an exact match in the pages file
				$re = new RegExp('[^\\w]' + $setting + ': ([^\r]*)\r*', 'i');
				if ($re.test($source_text)) {
					$value = RegExp.$1;
				}
			}
		}
		return $value;
	}
	
    function get_page_name($page_definition, $source) { // look for a page definition that exactly matches a given dynamic URL
        $page_name = "";
        $source = "\r" + $source; // this makes it easier to match a page definition on the first line of the file
        $re = new RegExp('[^\\w](\\w+)\:\\s+' + regex_quote($page_definition) + '[\&\s\r]', "");
        $page_name = ($re.test($source_text)) ? RegExp.$1 : "" ;
        return $page_name;
    }
	
	function get_page_names($source) { // return a list of all the page names in a page definitions file
		$page_names = Array();
		// in JScript, we could also set this up as a global match, then loop through the $matches array
		$re = new RegExp("(\\w+)\:\\s+[\\w]+", "");
		while ($re.test($source)) {
			$this_page_name = RegExp.$1;
			$page_names.push($this_page_name);
			$source = $source.replace($re, "");
		}
		return $page_names;
	}
	
	function get_directory_listing($directory) { // return a list of all the items in the specified directory
		$files = new Array();
		FSO = Server.CreateObject("Scripting.FileSystemObject")
		$dir = FSO.GetFolder(absolute_path($directory, "filesystem"));
		$dir_files = new Enumerator($dir.Files);
		if ($dir_files) {
			for (; !$dir_files.atEnd(); $dir_files.moveNext()) { // what the heck...
				$file = $dir_files.item().Name;
				if ($file.substr(0, 1) != ".") { $files.push($file); } // that gets files that don't start with a dot
			}
		}
		// in ASP, we have to do this once for files and once for folders
		$dir_folders = new Enumerator($dir.Subfolders);
		if ($dir_folders) {
			for (; !$dir_folders.atEnd(); $dir_folders.moveNext()) { // what the heck...
				$file = $dir_folders.item().Name;
				if ($file.substr(0, 1) != ".") { $files.push($file); } // that gets files that don't start with a dot
			}  
		}
		FSO = "";
		return $files;
	}

	function absolute_path($path, $method) { // convert a reference to a file within our site to an absolute URL
		if ($method == "filesystem") {
		
			$path = Server.MapPath($path);

		} else {
		
			$thisserver = String(Request.ServerVariables("HTTP_HOST"));
			$request = String(Request.ServerVariables("SCRIPT_NAME"));
			$re = new RegExp("\/([^=]*\/)contemplate\/", "i");
			if ($re.test($request)) { $thispath = RegExp.$1; }
			$re = new RegExp("\/([^=]*\/)assembled\/", "i");
			if ($re.test($request)) { $thispath = RegExp.$1; }
			
			// pass along the authentication information if present
			$auth_info = String(Request.ServerVariables("HTTP_AUTHORIZATION"));
			if (($auth_info)&&($auth_info.substr(0, 5) == "Basic")) {
				$auth_info = $auth_info.substr(5);
				$login = Base64Decode($auth_info);
				$login += "@";
			} else {
				$login = "";
			}
			
			$path = $path.replace("../", "http://" + $login + $thisserver + "/" + $thispath);
		
		}
		return $path;
	}

	function show_error($message) { // error display isn't as well developed here as in assembler, but we'll put this here so we can share more code
		return "Error: " + $message;
	}
	
%>

<script language="VBScript" runat="Server">

	' decode a base64-encoded string; this is a substitute for PHP's base64_decode() built-in function
	' http://www.webtutoriallist.com/list/finance.asp?url=http://www.pstruh.cz/tips/detpg_Base64.htm&name=Base64+decode+and+basic+authentication%20%20tutorial%20web%20page!

	Function Base64Decode(ByVal base64String)
	  'rfc1521
	  '1999 Antonin Foller, PSTRUH Software, http://pstruh.cz
	  Const Base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
	  Dim dataLength, sOut, groupBegin
	  
	  'remove white spaces, If any
	  base64String = Replace(base64String, vbCrLf, "")
	  base64String = Replace(base64String, vbTab, "")
	  base64String = Replace(base64String, " ", "")
	  
	  'The source must consists from groups with Len of 4 chars
	  dataLength = Len(base64String)
	  If dataLength Mod 4 <> 0 Then
		Err.Raise 1, "Base64Decode", "Bad Base64 string."
		Exit Function
	  End If
	
	  
	  ' Now decode each group:
	  For groupBegin = 1 To dataLength Step 4
		Dim numDataBytes, CharCounter, thisChar, thisData, nGroup, pOut
		' Each data group encodes up To 3 actual bytes.
		numDataBytes = 3
		nGroup = 0
	
		For CharCounter = 0 To 3
		  ' Convert each character into 6 bits of data, And add it To
		  ' an integer For temporary storage.  If a character is a '=', there
		  ' is one fewer data byte.  (There can only be a maximum of 2 '=' In
		  ' the whole string.)
	
		  thisChar = Mid(base64String, groupBegin + CharCounter, 1)
	
		  If thisChar = "=" Then
			numDataBytes = numDataBytes - 1
			thisData = 0
		  Else
			thisData = InStr(Base64, thisChar) - 1
		  End If
		  If thisData = -1 Then
			Err.Raise 2, "Base64Decode", "Bad character In Base64 string."
			Exit Function
		  End If
	
		  nGroup = 64 * nGroup + thisData
		Next
		
		'Hex splits the long To 6 groups with 4 bits
		nGroup = Hex(nGroup)
		
		'Add leading zeros
		nGroup = String(6 - Len(nGroup), "0") & nGroup
		
		'Convert the 3 byte hex integer (6 chars) To 3 characters
		pOut = Chr(CByte("&H" & Mid(nGroup, 1, 2))) + _
		  Chr(CByte("&H" & Mid(nGroup, 3, 2))) + _
		  Chr(CByte("&H" & Mid(nGroup, 5, 2)))
		
		'add numDataBytes characters To out string
		sOut = sOut & Left(pOut, numDataBytes)
	  Next
	
	  Base64Decode = sOut
	End Function

</script>

<%

	// set up some primary variables

	// figure out the location of the contemplate directory as shown in the browser, and use that as the basis for open commands;
	// this allows us to run the script from a symlink to the real contemplate folder, and paths will be relative to the
	// apparent, rather than the actual, location of assembler.asp
	// this will also prevent problems if Windows calculates relative paths from the server root
	$script_name = String(Request.ServerVariables("SCRIPT_NAME"));
	$script_name = $script_name.replace(/\\/g, "/");
	$re = new RegExp(".*\/([^\/]+)", "");
	if ($re.test($script_name)) { $script_name = RegExp.$1; }
	$script_location = (String(Request.ServerVariables("OS")).indexOf("Win") != -1) ? String(Request.ServerVariables("PATH_TRANSLATED")) : String(Request.ServerVariables("SCRIPT_FILENAME")) ;
	$script_location = $script_location.replace(/\\/g, "/");
	$script_location = $script_location.substr(0, $script_location.indexOf($script_name));
	
	$flatten = (Request.Form("flatten") != $undefined) ? String(Request.Form("flatten")) : "" ;
	$unflatten = (Request.Form("unflatten") != $undefined) ? String(Request.Form("unflatten")) : "" ;
	$input_file = (Request.Form("input_file") != $undefined) ? String(Request.Form("input_file")) : "" ;
	$output_file = (Request.Form("output_file") != $undefined) ? String(Request.Form("output_file")) : "" ;
	
	$successes = 0;
	$failures = 0;
	$changes = 0;


// read in a preferences (.ini) file if one exists
	$preferences = get_file("preferences.ini", "filesystem");
	if ($preferences) {
		$field_marker = get_setting($preferences, "field marker", 1, 1);
		$read_page_definitions_from = get_setting($preferences, "read page definitions from", 1, 1);
	}
	
	
// do a bit of processing on the settings, and set some defaults in case preferences.ini or individual settings are absent

	if ($field_marker == "") { $field_marker = "##"; }

	if ($read_page_definitions_from == "") { $read_page_definitions_from = "../contemplate/pages.txt"; }
	

// set up the HTML page
	
	Response.write ("<html>\r");

	Response.write ("<head>\r");

	Response.write ("<title>Contemplate(tm) Web Content Manager</title>\r");
	
	Response.write ("<link rel=stylesheet href=stylesheet.css type=text/css>\r");

	Response.write ("<script language=JavaScript> login = 0; </script>\r");
	Response.write ("<script language=JavaScript src=login/login.js></script>\r");		
	Response.write ("<script language=JavaScript> if (!login) { location = '../index.html'; } </script>\r");

	Response.write ("</head>\r");

	Response.write ("<body bgcolor=#FFFFFF>\r");
	Response.write ("<p class=title>Contemplate</p>\r");
	Response.write ("<p class=body><a href=index.html>Utilities menu</a> &gt; Flattener</p><br>\r");
	

// require a current version of the extractor before proceeding

	$required_version = 1.0;
	$extractor_text = get_file("assembler.asp", "filesystem");
	
	$matches = $extractor_text.match("version (\d+\.\d+)");
	if ($matches) {
		$installed_version = $matches[1];
		if ($installed_version < $required_version) {
			Response.write("Error: This version of the Flattener requires version "+$required_version+" or newer of Contemplate (assembler.asp).<p>");
			$stop = 1;
		}
	}
	

// present some options on the first run
	
	if ((!$flatten)&&(!$input_file)&&(!$unflatten)&&(!$stop)) {
	
	/////
	// show the intro page
	/////
			
		Response.write("<form name=flatten method=post>\r");
		
		Response.write("<p class=subheading>Flatten all dynamic pages</p>\r");
		Response.write("<p class=body>Before you do this, create a folder called \"flattened\" at the root level of your website, and give it world-write access (chmod a+w flattened)</p>\r");
		
		Response.write("<p class=body><input type=submit value=Flatten></p><br>\r");
		
		Response.write("<input type=hidden name=flatten value=1>\r");
		
		Response.write("</form>\r");
		
		Response.write("<form name=parse method=post>\r");
		
		Response.write("<p class=subheading>Parse individual files</p>\r");
		Response.write("<p class=body>Use this option to convert a file that contains links to dynamic pages, even if the file itself isn't dynamically generated<br>\r");
		Response.write("Enter paths relative to the site root</p>\r");
		
		Response.write("<table><tr valign=bottom><td>\r");
		
		Response.write("	<p class=body>Input file<br>\r");
		Response.write("	<input type=text name=input_file></p>\r");
		
		Response.write("</td><td>\r");
		
		Response.write("	<p class=body>Output file<br>\r");
		Response.write("	<input type=text name=output_file></p>\r");
		
		Response.write("</td></tr></table>\r");
		
		Response.write("<p class=body><input type=submit value=Parse></p><br>\r");
		
		Response.write("</form>\r");
	
		Response.write("<form name=unflatten method=post>\r");
		
		Response.write("<p class=subheading>Unflatten a flattened site</p>\r");
		Response.write("<p class=body>Use this option to update the dynamic files from which a flattened site was generated if the flattened files have been edited<br>\r");
		Response.write("Before you do this, give world-write access to all content files (chmod -R a+w content)</p>\r");
		
		Response.write("<p class=body><input type=submit value=Unflatten><input type=hidden name=unflatten value=1></p><br>\r");
		
		Response.write("</form>\r");
		
		Response.write("<div class=body>\r");
	

	} else {
	
	
	// grab the text of the pages.txt file; both options will use it
	
		$pages_file = get_file($read_page_definitions_from, "filesystem");
		
	
		if ($flatten) {
		
		////
		// flatten the site
		////
		
			// parse the pages file to get an array of page names and an array of URLs
			
				$pages = new Array(); $URLs = new Array();
				$page_names = get_page_names($pages_file);
				for ($i=0; $i<$page_names.length; $i++) {
					$this_page_name = $page_names[$i];
					$this_page = "../flattened/" + $this_page_name + ".html";
					$this_URL = "../contemplate/assembler.asp?page=" + $this_page_name + "&skip_rendering=1";
					$pages[$i] = $this_page;
					$URLs[$i] = $this_URL;
				}
				
				
			// open each URL, change its dynamic links to static ones, and save it to its page name
			
				for ($i=0; $i<$pages.length; $i++) {
				
					// get the dynamic page
					$file_missing = 0;
					$page_rendered = get_file($URLs[$i], "http");

					if ($file_missing) {
						$result += "<font color=red>" + $page_rendered + "</font><br>"; // that will contain the error if $file_missing == 1
						$failures++;
					} else {
					
						// convert all the dynamic URLs to flattened ones
						$page_rendered = convert_URLs($page_rendered, $pages[$i]);
										
						// save the flattened page
						FSO = Server.CreateObject("Scripting.FileSystemObject");
						$my_file = FSO.CreateTextFile(absolute_path($pages[$i], "filesystem"));
						if ((! FSO)||(! $my_file)) {
							$result += "<font color=red>Error: Can't open the file " + $pages[$i] + " for flattening.</font><br>";
							$failures++;
						} else {
							$my_file.WriteLine($page_rendered);
							$result += "Processing " + $pages[$i] + "<br>";
							$successes++;
						}
						$my_file = "";
						FSO = "";

						// provide feedback as the script runs
						Response.write($result);
						$result = "";
					
					}
				
				}
		
			// show success rate and, if errors, offer tips
		
				Response.write("<br><b>Created " + $successes + " files and encountered " + $failures + " errors</b><p>\r");
		
	
		} else if ($input_file) {
	
		/////
		// parse a single file
		////
		
			// open the file, change its dynamic links to static ones, and save it to its output location
			
				// in case the paths aren't relative to the contemplate folder
				$input_file = ($input_file.indexOf("../") != -1) ? $input_file : "../" + $input_file ;
				$output_file = ($output_file.indexOf("../") != -1) ? $output_file : "../" + $output_file ;
				
				// get the file
				$delimiter = ($input_file.indexOf("?") == -1) ? "?" : "&" ;
				$file = get_file($input_file + $delimiter + "skip_rendering=1", "http");

				// convert all the dynamic URLs to flattened ones
				$file = convert_URLs($file, $input_file);
			
				// save the parsed file
				FSO = Server.CreateObject("Scripting.FileSystemObject");
				$my_file = FSO.CreateTextFile(absolute_path($output_file, "filesystem"));
				if ((! FSO)||(! $my_file)) {
					$failures++;
				} else {
					$my_file.WriteLine($file);
				}
				$my_file = "";
				FSO = "";

			// show result
		
				if (!$failures) {
					Response.write("<b>Converted " + $input_file + " successfully</b><p>");
				} else {
					Response.write("Error: Couldn't open the file " + $output_file + " for saving.<br>");
					Response.write("<b>Failed to convert " + $input_file + "</b><p>");
				}
				
		
		} else if ($unflatten) {
	
		/////
		// move changes to the flattened files back into the dynamic files
		/////
		
			// get a list of flat pages
					
				$flat_files = get_directory_listing("../flattened/");
						 
			// open assembler.asp?page=$page&get_info=1 for each flat page, but skip if there's a flattener error
			
				//$flat_files = new Array("field_1.html"); // for testing one file at a time
				
				$dynamic_files = new Array();
				for ($i=0; $i<$flat_files.length; $i++) {
				
					$flat_files[$i] = "../flattened/" + $flat_files[$i];
					
					$dynamic_files[$i] = "../contemplate/assembler.asp?page=" + $flat_files[$i];
					$dynamic_files[$i] = $dynamic_files[$i].replace("page=../flattened/", "page=");
					$dynamic_files[$i] = $dynamic_files[$i].replace(/\.\w+$/, "");
					
					$flat_file = get_file($flat_files[$i], "filesystem");
					$dynamic_file =  get_file($dynamic_files[$i] + "&get_info=1&skip_rendering=1", "http");
					
					if ($dynamic_file.indexOf("Flattener error") != -1) {
						Response.write("<font color=red>Error: Couldn't find dynamic page for " + $flat_files[$i] + "</font><br>");
						$failures++;
					} else {
						Response.write("<br>Processing file " + $dynamic_files[$i] + "<br>");
						
						// something about the last character of each file prevented a match to the last template piece, so strip them off now
						$re = new RegExp('(.*).(<\/template_piece-.*)');
						if ($re.test($dynamic_file))  {
							$dynamic_file = $dynamic_file.replace($re, "$1" + "$2");
						}
						$flat_file = $flat_file.substr(0, $flat_file.length - 1);
						
						// convert flattened URLs in the flat file back to their dynamic counterparts for comparison
						$flat_file = unconvert_URLs($flat_file, $dynamic_file); // select one or the other URL option based on what's in the dynamic file
						if ($unconvert_error) {
							Response.write("<font color=red>" + $unconvert_error + "</font>");
							$failures++;
						} else {
						 
							// loop through the file info and collect all the template pieces
							$j = 1; $template_pieces = new Array();
							$re = new RegExp('<template_piece-' + $j + '>(.*)<\/template_piece-' + $j + '>');
							while ($re.test($dynamic_file)) {
								$template_pieces[($j-1)] = RegExp.$1;
								$j++;
								$re = new RegExp('<template_piece-' + $j + '>(.*)<\/template_piece-' + $j + '>'); // can we do the loop without repeating this line of code here?
							}
								
							// loop through template pieces and parse flat and dynamic files to make two arrays of content pieces
							$flat_file_copy = $flat_file;
							$flat_pieces = new Array();
							$dynamic_pieces = new Array();
							for ($j=0; $j<(($template_pieces.length)-1); $j++) {
							
								$changed = 0;
								$j_plus = $j+1; $j_plus_plus = $j+2;
								$next_piece = "flattener-no-match-flag";
								$temp = $flat_file_copy.substr(0, $template_pieces[$j].length);
								if ($temp == $template_pieces[$j]) {

									// strip the first template piece right off
									$flat_file_copy = $flat_file_copy.substr($template_pieces[$j].length);
									
									// then scan for a match for the second template piece
									$range = $flat_file_copy.length - $template_pieces[$j_plus].length;
									for ($k=0; $k<=$range; $k++) {
										if ($flat_file_copy.substr($k, $template_pieces[$j_plus].length) == $template_pieces[$j_plus]) {
											$next_piece = $flat_file_copy.substr(0, $k);
											$flat_file_copy = $flat_file_copy.substr($k, $flat_file_copy.length);
											$k = $range + 1;
										}
									}
									if ($next_piece == "flattener-no-match-flag") {
										$changed = 2;
									}
								} else {
									$changed = 1;
								}
								if ($changed) {
								//all the preceding lines except $j_plus = $j+1 could be avoided with this line, but it doesn't quite work -- too greedy?
								//if ($flat_file_copy !~ /\Q@template_pieces[$j]\E(.*?)(\Q@template_pieces[$j_plus]\E.*)/) {
									Response.write("<font color=red>Error: Template piece "+($j+$changed)+" has been changed in " + $flat_files[$i] + "</font><br>");
									Response.write("Hint: If using conditional tags, check to see that all conditions are the same as when flattened<br>");
									//Response.write("\r\r<template_piece " + $j_plus + ">" + $template_pieces[$j] + "</template_piece " + $j_plus + ">"); // debug
									//Response.write("\r\r<template_piece " + $j_plus_plus + ">" + $template_pieces[$j_plus] + "</template_piece " + $j_plus_plus + ">"); // debug
									//Response.write("\r\r<" + $flat_files[$i] + ">" + $flat_file_copy + "</" + $flat_files[$i] + ">"); // debug
									$failures++;
									$j = $template_pieces.length; // stop processing this file
								} else {
								
									$flat_pieces[$j] = $next_piece; // $1
									
									$re = new RegExp('<content-' + $j_plus + '>(.*)<\/content-' + $j_plus + '>');
									if ($re.test($dynamic_file)) {
										$dynamic_pieces[$j] = RegExp.$1;
									}

									// if content from flat file and dynamic file are different, open the content file and replace dynamic with flat
									if ($flat_pieces[$j] == $dynamic_pieces[$j]) {
										Response.write("Piece " + $j_plus + " is the same<br>");
									} else {
											
										// don't bother with certain embed types
										$re = new RegExp('<embed_type-' + $j_plus + '>random<\/embed_type-' + $j_plus + '>');
										$re2 = new RegExp('<embed_type-' + $j_plus + '>env_.+<\/embed_type-' + $j_plus + '>');
										$re3 = new RegExp('<embed_type-' + $j_plus + '>passthr.+<\/embed_type-' + $j_plus + '>');
										if ($re.test($dynamic_file)) {
											Response.write("Skipping random content in piece " + $j_plus + "<br>");
										} else if ($re2.test($dynamic_file)) {
											Response.write("Skipping environment variable in piece " + $j_plus + "<br>");
										} else if ($re3.test($dynamic_file)) {
											Response.write("Skipping passthru content in piece" + $j_plus + "<br>");
										} else {

											Response.write("<font color=green>Updating piece " + $j_plus + "</font><br>");
											
											// open, update, and save
											$this_file = ""; $this_failure = 0;
											$re = new RegExp('<content_file-' + $j_plus + '>(.*)<\/content_file-' + $j_plus + '>');
											if ($re.test($dynamic_file)) {
												$this_file = RegExp.$1;
												$content = get_file($this_file, "filesystem");
												
												$content = $content.replace($dynamic_pieces[$j], $flat_pieces[$j]);
												
												FSO = Server.CreateObject("Scripting.FileSystemObject");
												$my_file = FSO.CreateTextFile(absolute_path($this_file, "filesystem"), 1);
												if ((! FSO)||(! $my_file)) {
													$failures++;
												} else {
													$my_file.WriteLine($content);
													if ($changed_files.indexOf($this_file) == -1) {
														$changed_files += $this_file + ",";
													}
												}
												$my_file = "";
												FSO = "";
											} else {
												$this_failure++;
											}

											if ($this_failure) {
												if (!$this_file) { $this_file = "(unknown)"; }
												Response.write("<font color=red>Error: Couldn't save changes to content file " + $this_file + "</font><br>");
												$failures++;
											} else {
												$changes++;
											}
											
											//Response.write("<flat piece>" + $flat_pieces[$j] + "</flat piece><p>\r\r"); // debug
											//Response.write("<dynamic piece>" + $dynamic_pieces[$j] + "</dynamic piece><p>\r\r"); // debug
											//Response.write("<flat file>" + $flat_file + "</flat file><p>\r\r"); // debug
											//Response.write("<dynamic file>" + $dynamic_file + "</dynamic file><p>\r\r"); // debug
										
										}
										
									}
								
								}
								
							}
									
						}
					
					}
				
				}
				
			// show result
		
				if ($changed_files.length > 0) {
					$changed_files = $changed_files.substr(0, $changed_files.length - 1);
					$changed_files = $changed_files.split(",");
					$changed_files_count = $changed_files.length;
				} else {
					$changed_files_count = 0;
				}
				Response.write("<br><b>Updated " + $changes + " fields in " + $changed_files_count + " files with " + $failures + " errors</b><p>");
				
		}
	
		Response.write("</div>");

		if (!$stop) {
			Response.write("<p class=body><a href=JavaScript:history.back()>Back</a></p>");
		}
				
		Response.write($output); // we don't use the $output variable in this script, but this helps us share code with assembler.asp
				

// finish off a big conditional up there

	}	
	
	
// we're done!

	Response.write("</body></html>");

%>
